diff --git a/gcc/analyzer/region-model.cc b/gcc/analyzer/region-model.cc
index 0794be9a583..e7785eb54d1 100644
--- a/gcc/analyzer/region-model.cc
+++ b/gcc/analyzer/region-model.cc
@@ -6251,803 +2246,277 @@ region_model::apply_constraints_for_gswitch (const switch_cfg_superedge &edge,
     }
 }
 
-/* Get the root_region within this model (guaranteed to be non-null).  */
-
-root_region *
-region_model::get_root_region () const
-{
-  return get_region<root_region> (m_root_rid);
-}
-
-/* Get the region_id of this model's stack region (if any).  */
-
-region_id
-region_model::get_stack_region_id () const
-{
-  return get_root_region ()->get_stack_region_id ();
-}
-
-/* Create a new frame_region for a call to FUN and push it onto
-   the stack.
-
-   If ARG_SIDS is non-NULL, use it to populate the parameters
-   in the new frame.
-   Otherwise, populate them with unknown values.
-
-   Return the region_id of the new frame_region.  */
-
-region_id
-region_model::push_frame (function *fun, vec<svalue_id> *arg_sids,
-			  region_model_context *ctxt)
-{
-  return get_root_region ()->push_frame (this, fun, arg_sids, ctxt);
-}
-
-/* Get the region_id of the top-most frame in this region_model's stack,
-   if any.  */
-
-region_id
-region_model::get_current_frame_id () const
-{
-  return get_root_region ()->get_current_frame_id (*this);
-}
-
-/* Get the function of the top-most frame in this region_model's stack.
-   There must be such a frame.  */
-
-function *
-region_model::get_current_function () const
-{
-  region_id frame_id = get_current_frame_id ();
-  frame_region *frame = get_region<frame_region> (frame_id);
-  return frame->get_function ();
-}
-
-/* Pop the topmost frame_region from this region_model's stack;
-   see the comment for stack_region::pop_frame.  */
-
-void
-region_model::pop_frame (region_id result_dst_rid,
-			 bool purge, purge_stats *out,
-			 region_model_context *ctxt)
-{
-  get_root_region ()->pop_frame (this, result_dst_rid, purge, out, ctxt);
-}
-
-/* Get the number of frames in this region_model's stack.  */
-
-int
-region_model::get_stack_depth () const
-{
-  stack_region *stack = get_root_region ()->get_stack_region (this);
-  if (stack)
-    return stack->get_num_frames ();
-  else
-    return 0;
-}
-
-/* Get the function * at DEPTH within the call stack.  */
-
-function *
-region_model::get_function_at_depth (unsigned depth) const
-{
-  stack_region *stack = get_root_region ()->get_stack_region (this);
-  gcc_assert (stack);
-  region_id frame_rid = stack->get_frame_rid (depth);
-  frame_region *frame = get_region <frame_region> (frame_rid);
-  return frame->get_function ();
-}
-
-/* Get the region_id of this model's globals region (if any).  */
-
-region_id
-region_model::get_globals_region_id () const
-{
-  return get_root_region ()->get_globals_region_id ();
-}
-
-/* Add SVAL to this model, taking ownership, and returning its new
-   svalue_id.  */
-
-svalue_id
-region_model::add_svalue (svalue *sval)
-{
-  gcc_assert (sval);
-  m_svalues.safe_push (sval);
-  return svalue_id::from_int (m_svalues.length () - 1);
-}
-
-/* Change the meaning of SID to be NEW_SVAL
-   (e.g. when deferencing an unknown pointer, the pointer
-   becomes a pointer to a symbolic region, so that all users
-   of the former unknown pointer are now effectively pointing
-   at the same region).  */
+/* For use with push_frame when handling a top-level call within the analysis.
+   PARAM has a defined but unknown initial value.
+   Anything it points to has escaped, since the calling context "knows"
+   the pointer, and thus calls to unknown functions could read/write into
+   the region.  */
 
 void
-region_model::replace_svalue (svalue_id sid, svalue *new_sval)
-{
-  gcc_assert (!sid.null_p ());
-  int idx = sid.as_int ();
-
-  gcc_assert (m_svalues[idx]);
-  gcc_assert (m_svalues[idx]->get_type () == new_sval->get_type ());
-  delete m_svalues[idx];
-
-  m_svalues[idx] = new_sval;
-}
-
-/* Add region R to this model, taking ownership, and returning its new
-   region_id.  */
-
-region_id
-region_model::add_region (region *r)
-{
-  gcc_assert (r);
-  m_regions.safe_push (r);
-  return region_id::from_int (m_regions.length () - 1);
-}
-
-/* Return the svalue with id SVAL_ID, or NULL for a null id.  */
-
-svalue *
-region_model::get_svalue (svalue_id sval_id) const
-{
-  if (sval_id.null_p ())
-    return NULL;
-  return m_svalues[sval_id.as_int ()];
-}
-
-/* Return the region with id RID, or NULL for a null id.  */
-
-region *
-region_model::get_region (region_id rid) const
-{
-  if (rid.null_p ())
-    return NULL;
-  return m_regions[rid.as_int ()];
-}
-
-/* Make a region of an appropriate subclass for TYPE,
-   with parent PARENT_RID, or return NULL for types we don't yet know
-   how to handle.  */
-
-static region *
-make_region_for_type (region_id parent_rid, tree type)
-{
-  gcc_assert (TYPE_P (type));
-
-  if (INTEGRAL_TYPE_P (type)
-      || SCALAR_FLOAT_TYPE_P (type)
-      || POINTER_TYPE_P (type)
-      || TREE_CODE (type) == COMPLEX_TYPE
-      || TREE_CODE (type) == VECTOR_TYPE)
-    return new primitive_region (parent_rid, type);
-
-  if (TREE_CODE (type) == RECORD_TYPE)
-    return new struct_region (parent_rid, type);
-
-  if (TREE_CODE (type) == ARRAY_TYPE)
-    return new array_region (parent_rid, type);
-
-  if (TREE_CODE (type) == UNION_TYPE)
-    return new union_region (parent_rid, type);
-
-  if (FUNC_OR_METHOD_TYPE_P (type))
-    return new function_region (parent_rid, type);
-
-  /* If we have a void *, make a new symbolic region.  */
-  if (VOID_TYPE_P (type))
-    return new symbolic_region (parent_rid, type, false);
-
-  return NULL;
-}
-
-/* Add a region with type TYPE and parent PARENT_RID.  */
-
-region_id
-region_model::add_region_for_type (region_id parent_rid, tree type,
+region_model::on_top_level_param (tree param,
 				   region_model_context *ctxt)
 {
-  if (type)
+  if (POINTER_TYPE_P (TREE_TYPE (param)))
     {
-      gcc_assert (TYPE_P (type));
-
-      if (region *new_region = make_region_for_type (parent_rid, type))
-	return add_region (new_region);
+      const region *param_reg = get_lvalue (param, ctxt);
+      const svalue *init_ptr_sval
+	= m_mgr->get_or_create_initial_value (param_reg);
+      const region *pointee_reg = m_mgr->get_symbolic_region (init_ptr_sval);
+      m_store.mark_as_escaped (pointee_reg);
     }
-
-  /* If we can't handle TYPE, return a placeholder region, and stop
-     exploring this path.  */
-  return make_region_for_unexpected_tree_code (ctxt, type,
-					       dump_location_t ());
 }
 
-/* Helper class for region_model::purge_unused_svalues.  */
-
-class restrict_to_used_svalues : public purge_criteria
-{
-public:
-  restrict_to_used_svalues (const auto_sbitmap &used) : m_used (used) {}
-
-  bool should_purge_p (svalue_id sid) const FINAL OVERRIDE
-  {
-    gcc_assert (!sid.null_p ());
-    return !bitmap_bit_p (m_used, sid.as_int ());
-  }
+/* Update this region_model to reflect pushing a frame onto the stack
+   for a call to FUN.
 
-private:
-  const auto_sbitmap &m_used;
-};
+   If ARG_SVALS is non-NULL, use it to populate the parameters
+   in the new frame.
+   Otherwise, the params have their initial_svalues.
 
-/* Remove unused svalues from this model, accumulating stats into STATS.
-   Unused svalues are deleted.  Doing so could reorder the svalues, and
-   thus change the meaning of svalue_ids.
-
-   If CTXT is non-NULL, then it is notified about svalue_id remappings,
-   and about svalue_ids that are about to be deleted.  This allows e.g.
-   for warning about resource leaks, for the case where the svalue
-   represents a resource handle in the user code (e.g. a FILE * or a malloc
-   buffer).
-
-   Amongst other things, removing unused svalues is important for ensuring
-   that the analysis of loops terminates.  Otherwise, we could generate a
-   succession of models with unreferenced "unknown" values, where the
-   number of redundant unknown values could grow without bounds, and each
-   such model would be treated as distinct.
-
-   If KNOWN_USED_SIDS is non-NULL, treat *KNOWN_USED_SIDS as used (this is for
-   handling values being returned from functions as their frame is popped,
-   since otherwise we'd have to simultaneously determine both the rvalue
-   of the return expr in the callee frame and the lvalue for the gcall's
-   assignment in the caller frame, and it seems cleaner to express all
-   lvalue and rvalue lookups implicitly relative to a "current" frame).
-   The svalue_ids in *KNOWN_USED_SIDS are not remapped and hence this
-   call makes it invalid.  */
+   Return the frame_region for the new frame.  */
 
-void
-region_model::purge_unused_svalues (purge_stats *stats,
-				    region_model_context *ctxt,
-				    svalue_id_set *known_used_sids)
+const region *
+region_model::push_frame (function *fun, const vec<const svalue *> *arg_svals,
+			  region_model_context *ctxt)
 {
-  // TODO: might want to avoid a vfunc call just to do logging here:
-  logger *logger = ctxt ? ctxt->get_logger () : NULL;
-
-  LOG_SCOPE (logger);
-
-  auto_sbitmap used (m_svalues.length ());
-  bitmap_clear (used);
-
-  if (known_used_sids)
-    {
-      /* We can't use an sbitmap for known_used_sids as the number of
-	 svalues could have grown since it was created.  */
-      for (unsigned i = 0; i < get_num_svalues (); i++)
-	if (known_used_sids->svalue_p (svalue_id::from_int (i)))
-	  bitmap_set_bit (used, i);
-    }
-
-  /* Walk the regions, marking sids that are used.  */
-  unsigned i;
-  region *r;
-  FOR_EACH_VEC_ELT (m_regions, i, r)
-    {
-      svalue_id sid = r->get_value_direct ();
-      if (!sid.null_p ())
-	bitmap_set_bit (used, sid.as_int ());
-    }
-
-  /* Now purge any constraints involving svalues we don't care about.  */
-  restrict_to_used_svalues criterion (used);
-  m_constraints->purge (criterion, stats);
-
-  /* Mark any sids that are in constraints that survived.  */
-  {
-    equiv_class *ec;
-    FOR_EACH_VEC_ELT (m_constraints->m_equiv_classes, i, ec)
-      {
-	int j;
-	svalue_id *sid;
-	FOR_EACH_VEC_ELT (ec->m_vars, j, sid)
-	  {
-	    gcc_assert (!sid->null_p ());
-	    bitmap_set_bit (used, sid->as_int ());
-	  }
-      }
-  }
-
-  /* Build a mapping from old-sid to new-sid so that we can preserve
-     order of the used IDs and move all redundant ones to the end.
-     Iterate though svalue IDs, adding used ones to the front of
-     the new list, and unused ones to the back.  */
-  svalue_id_map map (m_svalues.length ());
-  int next_used_new_sid = 0;
-  int after_next_unused_new_sid = m_svalues.length ();
-  for (unsigned i = 0; i < m_svalues.length (); i++)
-    {
-      svalue_id src (svalue_id::from_int (i));
-      if (bitmap_bit_p (used, i))
-	{
-	  if (logger)
-	    logger->log ("sv%i is used", i);
-	  map.put (src, svalue_id::from_int (next_used_new_sid++));
-	}
-      else
-	{
-	  if (logger)
-	    logger->log ("sv%i is unused", i);
-	  map.put (src, svalue_id::from_int (--after_next_unused_new_sid));
-	}
-    }
-  /* The two insertion points should have met.  */
-  gcc_assert (next_used_new_sid == after_next_unused_new_sid);
-
-  /* Now walk the regions and the constraints, remapping sids,
-     so that all the redundant svalues are at the end.  */
-  remap_svalue_ids (map);
-
-  if (logger)
-    {
-      logger->start_log_line ();
-      logger->log_partial ("map: ");
-      map.dump_to_pp (logger->get_printer ());
-      logger->end_log_line ();
-    }
-
-  /* Notify any client about the remapping and pending deletion.
-     Potentially this could trigger leak warnings.  */
-  if (ctxt)
-    {
-      ctxt->remap_svalue_ids (map);
-      int num_client_items_purged
-	= ctxt->on_svalue_purge (svalue_id::from_int (next_used_new_sid), map);
-      if (stats)
-	stats->m_num_client_items += num_client_items_purged;
-    }
-
-  /* Drop the redundant svalues from the end of the vector.  */
-  while ((signed)m_svalues.length () > next_used_new_sid)
+  m_current_frame = m_mgr->get_frame_region (m_current_frame, fun);
+  if (arg_svals)
     {
-      if (logger)
+      /* Arguments supplied from a caller frame.  */
+      tree fndecl = fun->decl;
+      unsigned idx = 0;
+      for (tree iter_parm = DECL_ARGUMENTS (fndecl); iter_parm;
+	   iter_parm = DECL_CHAIN (iter_parm), ++idx)
 	{
-	  svalue_id victim = svalue_id::from_int (m_svalues.length () - 1);
-	  logger->log ("deleting sv%i (was sv%i)",
-		       victim.as_int (),
-		       map.get_src_for_dst (victim).as_int ());
-	}
-      delete m_svalues.pop ();
-      if (stats)
-	stats->m_num_svalues++;
-    }
-
-  validate ();
-}
-
-/* Renumber the svalues within this model according to MAP.  */
-
-void
-region_model::remap_svalue_ids (const svalue_id_map &map)
-{
-  /* Update IDs within regions.  */
-  unsigned i;
-  region *r;
-  FOR_EACH_VEC_ELT (m_regions, i, r)
-    r->remap_svalue_ids (map);
-
-  /* Update IDs within ECs within constraints.  */
-  m_constraints->remap_svalue_ids (map);
-
-  /* Build a reordered svalues vector.  */
-  auto_vec<svalue *> new_svalues (m_svalues.length ());
-  for (unsigned i = 0; i < m_svalues.length (); i++)
-    {
-      svalue_id dst (svalue_id::from_int (i));
-      svalue_id src = map.get_src_for_dst (dst);
-      new_svalues.quick_push (get_svalue (src));
-    }
-
-  /* Copy over the reordered vec to m_svalues.  */
-  m_svalues.truncate (0);
-  gcc_assert (m_svalues.space (new_svalues.length ()));
-  svalue *sval;
-  FOR_EACH_VEC_ELT (new_svalues, i, sval)
-    m_svalues.quick_push (sval);
-}
-
-/* Renumber the regions within this model according to MAP.  */
-
-void
-region_model::remap_region_ids (const region_id_map &map)
-{
-  /* Update IDs within regions.  */
-  unsigned i;
-  region *r;
-  FOR_EACH_VEC_ELT (m_regions, i, r)
-    r->remap_region_ids (map);
-
-  /* Update IDs within svalues.  */
-  svalue *sval;
-  FOR_EACH_VEC_ELT (m_svalues, i, sval)
-    sval->remap_region_ids (map);
-
-  /* Build a reordered regions vector.  */
-  auto_vec<region *> new_regions (m_regions.length ());
-  for (unsigned i = 0; i < m_regions.length (); i++)
-    {
-      region_id dst (region_id::from_int (i));
-      region_id src = map.get_src_for_dst (dst);
-      new_regions.quick_push (get_region (src));
-    }
-
-  /* Copy over the reordered vec to m_regions.  */
-  m_regions.truncate (0);
-  gcc_assert (m_regions.space (new_regions.length ()));
-  FOR_EACH_VEC_ELT (new_regions, i, r)
-    m_regions.quick_push (r);
-}
-
-/* Delete all regions within SET_TO_PURGE, remapping region IDs for
-   other regions.  It's required that there are no uses of the
-   regions within the set (or the region IDs will become invalid).
-
-   Accumulate stats to STATS.  */
-
-void
-region_model::purge_regions (const region_id_set &set_to_purge,
-			     purge_stats *stats,
-			     logger *)
-{
-  /* Build a mapping from old-rid to new-rid so that we can preserve
-     order of the used IDs and move all redundant ones to the end.
-     Iterate though region IDs, adding used ones to the front of
-     the new list, and unused ones to the back.  */
-  region_id_map map (m_regions.length ());
-  int next_used_new_rid = 0;
-  int after_next_unused_new_rid = m_regions.length ();
-  for (unsigned i = 0; i < m_regions.length (); i++)
-    {
-      region_id src (region_id::from_int (i));
-      if (set_to_purge.region_p (src))
-	map.put (src, region_id::from_int (--after_next_unused_new_rid));
-      else
-	map.put (src, region_id::from_int (next_used_new_rid++));
-    }
-  /* The two insertion points should have met.  */
-  gcc_assert (next_used_new_rid == after_next_unused_new_rid);
-
-  /* Now walk the regions and svalues, remapping rids,
-     so that all the redundant regions are at the end.  */
-  remap_region_ids (map);
-
-  /* Drop the redundant regions from the end of the vector.  */
-  while ((signed)m_regions.length () > next_used_new_rid)
-    {
-      delete m_regions.pop ();
-      if (stats)
-	stats->m_num_regions++;
-    }
-}
-
-/* Populate *OUT with RID and all of its descendents.
-   If EXCLUDE_RID is non-null, then don't add it or its descendents.  */
-
-void
-region_model::get_descendents (region_id rid, region_id_set *out,
-			       region_id exclude_rid) const
-{
-  out->add_region (rid);
+	  /* If there's a mismatching declaration, the call stmt might
+	     not have enough args.  Handle this case by leaving the
+	     rest of the params as uninitialized.  */
+	  if (idx >= arg_svals->length ())
+	    break;
+	  const svalue *arg_sval = (*arg_svals)[idx];
+	  const region *parm_reg = get_lvalue (iter_parm, ctxt);
+	  set_value (parm_reg, arg_sval, ctxt);
 
-  bool changed = true;
-  while (changed)
-    {
-      changed = false;
-      unsigned i;
-      region *r;
-      FOR_EACH_VEC_ELT (m_regions, i, r)
-	{
-	  region_id iter_rid = region_id::from_int (i);
-	  if (iter_rid == exclude_rid)
-	    continue;
-	  if (!out->region_p (iter_rid))
+	  /* Also do it for default SSA name (sharing the same value).  */
+	  tree parm_default_ssa = ssa_default_def (fun, iter_parm);
+	  if (parm_default_ssa)
 	    {
-	      region_id parent_rid = r->get_parent ();
-	      if (!parent_rid.null_p ())
-		if (out->region_p (parent_rid))
-		  {
-		    out->add_region (iter_rid);
-		    changed = true;
-		  }
+	      const region *defssa_reg = get_lvalue (parm_default_ssa, ctxt);
+	      set_value (defssa_reg, arg_sval, ctxt);
 	    }
 	}
     }
-}
-
-/* Delete RID and all descendent regions.
-   Find any pointers to such regions; convert them to
-   poisoned values of kind PKIND.
-   Accumulate stats on purged entities into STATS.  */
-
-void
-region_model::delete_region_and_descendents (region_id rid,
-					     enum poison_kind pkind,
-					     purge_stats *stats,
-					     logger *logger)
-{
-  /* Find all child and descendent regions.  */
-  region_id_set descendents (this);
-  get_descendents (rid, &descendents, region_id::null ());
-
-  /* Find any pointers to such regions; convert to poisoned.  */
-  poison_any_pointers_to_bad_regions (descendents, pkind);
-
-  /* Delete all such regions.  */
-  purge_regions (descendents, stats, logger);
-}
-
-/* Find any pointers to regions within BAD_REGIONS; convert them to
-   poisoned values of kind PKIND.  */
-
-void
-region_model::poison_any_pointers_to_bad_regions (const region_id_set &
-						    bad_regions,
-						  enum poison_kind pkind)
-{
-  int i;
-  svalue *sval;
-  FOR_EACH_VEC_ELT (m_svalues, i, sval)
-    if (region_svalue *ptr_sval = sval->dyn_cast_region_svalue ())
-      {
-	region_id ptr_dst = ptr_sval->get_pointee ();
-	if (!ptr_dst.null_p ())
-	  if (bad_regions.region_p (ptr_dst))
-	    replace_svalue
-	      (svalue_id::from_int (i),
-	       new poisoned_svalue (pkind, sval->get_type ()));
-      }
-}
-
-/* Attempt to merge THIS with OTHER_MODEL, writing the result
-   to OUT_MODEL, and populating SID_MAPPING.  */
-
-bool
-region_model::can_merge_with_p (const region_model &other_model,
-				region_model *out_model,
-				svalue_id_merger_mapping *sid_mapping) const
-{
-  gcc_assert (m_root_rid == other_model.m_root_rid);
-  gcc_assert (m_root_rid.as_int () == 0);
-  gcc_assert (sid_mapping);
-  gcc_assert (out_model);
-
-  model_merger merger (this, &other_model, out_model, sid_mapping);
-
-  if (!root_region::can_merge_p (get_root_region (),
-				 other_model.get_root_region (),
-				 out_model->get_root_region (),
-				 &merger))
-    return false;
-
-  /* Merge constraints.  */
-  constraint_manager::merge (*m_constraints,
-			     *other_model.m_constraints,
-			     out_model->m_constraints,
-			     merger);
-
-  out_model->validate ();
-
-  /* The merged model should be simpler (or as simple) as the inputs.  */
-#if 0
-  gcc_assert (out_model->m_svalues.length () <= m_svalues.length ());
-  gcc_assert (out_model->m_svalues.length ()
-	      <= other_model.m_svalues.length ());
-#endif
-  gcc_assert (out_model->m_regions.length () <= m_regions.length ());
-  gcc_assert (out_model->m_regions.length ()
-	      <= other_model.m_regions.length ());
-  // TODO: same, for constraints
+  else
+    {
+      /* Otherwise we have a top-level call within the analysis.  The params
+	 have defined but unknown initial values.
+	 Anything they point to has escaped.  */
+      tree fndecl = fun->decl;
+      for (tree iter_parm = DECL_ARGUMENTS (fndecl); iter_parm;
+	   iter_parm = DECL_CHAIN (iter_parm))
+	{
+	  on_top_level_param (iter_parm, ctxt);
+	  /* TODO: also do it for default SSA name (have them share the
+	     same unknown initial value).  */
+	  tree parm_default_ssa = ssa_default_def (fun, iter_parm);
+	  if (parm_default_ssa)
+	    on_top_level_param (parm_default_ssa, ctxt);
+	}
+    }
 
-  return true;
+  return m_current_frame;
 }
 
-/* As above, but supply a placeholder svalue_id_merger_mapping
-   instance to be used and receive output.  For use in selftests.  */
+/* Get the function of the top-most frame in this region_model's stack.
+   There must be such a frame.  */
 
-bool
-region_model::can_merge_with_p (const region_model &other_model,
-				region_model *out_model) const
+function *
+region_model::get_current_function () const
 {
-  svalue_id_merger_mapping sid_mapping (*this, other_model);
-  return can_merge_with_p (other_model, out_model, &sid_mapping);
+  const frame_region *frame = get_current_frame ();
+  gcc_assert (frame);
+  return frame->get_function ();
 }
 
-/* For debugging purposes: look for a region within this region_model
-   for a decl named NAME (or an SSA_NAME for such a decl),
-   returning its value, or svalue_id::null if none are found.  */
+/* Pop the topmost frame_region from this region_model's stack;
 
-svalue_id
-region_model::get_value_by_name (const char *name) const
-{
-  gcc_assert (name);
-  tree identifier = get_identifier (name);
-  return get_root_region ()->get_value_by_name (identifier, *this);
-}
+   FIXME:
+   If RESULT_DST_RID is non-null, copy any return value from the frame
+   into RESULT_DST_RID's region.
 
-/* Generate or reuse an svalue_id within this model for an index
-   into an array of type PTR_TYPE, based on OFFSET_SID.  */
+   FIXME:
+   Purge the frame region and all its descendent regions.
+   Convert any pointers that point into such regions into
+   POISON_KIND_POPPED_STACK svalues.  */
 
-svalue_id
-region_model::convert_byte_offset_to_array_index (tree ptr_type,
-						  svalue_id offset_sid)
+void
+region_model::pop_frame (const region *result_dst_reg,
+			 const svalue **out_result,
+			 region_model_context *ctxt)
 {
-  gcc_assert (POINTER_TYPE_P (ptr_type));
+  gcc_assert (m_current_frame);
 
-  if (tree offset_cst = maybe_get_constant (offset_sid))
+  /* Evaluate the result, within the callee frame.  */
+  const frame_region *frame_reg = m_current_frame;
+  tree fndecl = m_current_frame->get_function ()->decl;
+  tree result = DECL_RESULT (fndecl);
+  if (result && TREE_TYPE (result) != void_type_node)
     {
-      tree elem_type = TREE_TYPE (ptr_type);
-
-      /* Arithmetic on void-pointers is a GNU C extension, treating the size
-	 of a void as 1.
-	 https://gcc.gnu.org/onlinedocs/gcc/Pointer-Arith.html  */
-      if (TREE_CODE (elem_type) == VOID_TYPE)
-	return offset_sid;
-
-      /* First, use int_size_in_bytes, to reject the case where we have an
-	 incomplete type, or a non-constant value.  */
-      HOST_WIDE_INT hwi_byte_size = int_size_in_bytes (elem_type);
-      if (hwi_byte_size > 0)
+      if (result_dst_reg)
 	{
-	  /* Now call size_in_bytes to get the answer in tree form.  */
-	  tree byte_size = size_in_bytes (elem_type);
-	  gcc_assert (byte_size);
-	  /* Try to get a constant by dividing, ensuring that we're in a
-	     signed representation first.  */
-	  tree index
-	    = fold_binary (TRUNC_DIV_EXPR, ssizetype,
-			   fold_convert (ssizetype, offset_cst),
-			   fold_convert (ssizetype, byte_size));
-	  if (index && TREE_CODE (index) == INTEGER_CST)
-	    return get_or_create_constant_svalue (index);
+	  /* Copy the result to RESULT_DST_REG.  */
+	  copy_region (result_dst_reg,
+		       get_lvalue (result, ctxt),
+		       ctxt);
 	}
+      if (out_result)
+	*out_result = get_rvalue (result, ctxt);
     }
 
-  /* Otherwise, we don't know the array index; generate a new unknown value.
-     TODO: do we need to capture the relationship between two unknown
-     values (the offset and the index)?  */
-  return add_svalue (new unknown_svalue (integer_type_node));
-}
+  /* Pop the frame.  */
+  m_current_frame = m_current_frame->get_calling_frame ();
 
-/* Get a region of type TYPE for PTR_SID[OFFSET_SID/sizeof (*PTR_SID)].
+  unbind_region_and_descendents (frame_reg,POISON_KIND_POPPED_STACK);
+}
 
-   If OFFSET_SID is known to be zero, then dereference PTR_SID.
-   Otherwise, impose a view of "typeof(*PTR_SID)[]" on *PTR_SID,
-   and then get a view of type TYPE on the relevant array element.  */
+/* Get the number of frames in this region_model's stack.  */
 
-region_id
-region_model::get_or_create_mem_ref (tree type,
-				     svalue_id ptr_sid,
-				     svalue_id offset_sid,
-				     region_model_context *ctxt)
+int
+region_model::get_stack_depth () const
 {
-  svalue *ptr_sval = get_svalue (ptr_sid);
-  tree ptr_type = ptr_sval->get_type ();
-  gcc_assert (ptr_type);
-
-  region_id raw_rid = deref_rvalue (ptr_sid, ctxt);
+  const frame_region *frame = get_current_frame ();
+  if (frame)
+    return frame->get_stack_depth ();
+  else
+    return 0;
+}
 
-  svalue *offset_sval = get_svalue (offset_sid);
-  tree offset_type = offset_sval->get_type ();
-  gcc_assert (offset_type);
+/* FIXME.  */
 
-  if (constant_svalue *cst_sval = offset_sval->dyn_cast_constant_svalue ())
+const frame_region *
+region_model::get_frame_at_index (int index) const
+{
+  const frame_region *frame = get_current_frame ();
+  if (frame)
     {
-      if (zerop (cst_sval->get_constant ()))
+      gcc_assert (index >= 0);
+      gcc_assert (index <= frame->get_index ());
+      while (index != frame->get_index ())
 	{
-	  /* Handle the zero offset case.  */
-	  return get_or_create_view (raw_rid, type, ctxt);
+	  frame = frame->get_calling_frame ();
+	  gcc_assert (frame);
 	}
+      return frame;
+    }
+  else
+    return 0;
+}
 
-      /* If we're already within an array of the correct type,
-	 then we want to reuse that array, rather than starting
-	 a new view.
-	 If so, figure out our raw_rid's offset from its parent,
-	 if we can, and use that to offset OFFSET_SID, and create
-	 the element within the parent region.  */
-      region *raw_reg = get_region (raw_rid);
-      region_id parent_rid = raw_reg->get_parent ();
-      tree parent_type = get_region (parent_rid)->get_type ();
-      if (parent_type
-	  && TREE_CODE (parent_type) == ARRAY_TYPE)
-	{
-	  // TODO: check we have the correct parent type
-	  array_region *parent_array = get_region <array_region> (parent_rid);
-	  array_region::key_t key_for_raw_rid;
-	  if (parent_array->get_key_for_child_region (raw_rid,
-						      &key_for_raw_rid))
-	    {
-	      /* Convert from offset to index.  */
-	      svalue_id index_sid
-		= convert_byte_offset_to_array_index (ptr_type, offset_sid);
-	      if (tree index_cst
-		    = get_svalue (index_sid)->maybe_get_constant ())
-		{
-		  array_region::key_t index_offset
-		    = array_region::key_from_constant (index_cst);
-		  array_region::key_t index_rel_to_parent
-		    = key_for_raw_rid + index_offset;
-		  tree index_rel_to_parent_cst
-		    = wide_int_to_tree (integer_type_node,
-					index_rel_to_parent);
-		  svalue_id index_sid
-		    = get_or_create_constant_svalue (index_rel_to_parent_cst);
-
-		  /* Carry on, using the parent region and adjusted index.  */
-		  region_id element_rid
-		    = parent_array->get_element (this, raw_rid, index_sid,
-						 ctxt);
-		  return get_or_create_view (element_rid, type, ctxt);
-		}
-	    }
-	}
+/* Unbind svalues for any regions in REG and below.
+   Find any pointers to such regions; convert them to
+   poisoned values of kind PKIND.  */
+
+void
+region_model::unbind_region_and_descendents (const region *reg,
+					     enum poison_kind pkind)
+{
+  /* Gather a set of base regions to be unbound.  */
+  hash_set<const region *> base_regs;
+  for (store::cluster_map_t::iterator iter = m_store.begin ();
+       iter != m_store.end (); ++iter)
+    {
+      const region *iter_base_reg = (*iter).first;
+      if (iter_base_reg->descendent_of_p (reg))
+	base_regs.add (iter_base_reg);
     }
+  for (hash_set<const region *>::iterator iter = base_regs.begin ();
+       iter != base_regs.end (); ++iter)
+    m_store.purge_cluster (*iter);
 
-  tree array_type = build_array_type (TREE_TYPE (ptr_type),
-				      integer_type_node);
-  region_id array_view_rid = get_or_create_view (raw_rid, array_type, ctxt);
-  array_region *array_reg = get_region <array_region> (array_view_rid);
+  /* Find any pointers to REG or its descendents; convert to poisoned.  */
+  poison_any_pointers_to_descendents (reg, pkind);
+}
 
-  svalue_id index_sid
-    = convert_byte_offset_to_array_index (ptr_type, offset_sid);
+/* Implementation of BindingVisitor.
+   Update the bound svalues for regions below REG to use poisoned
+   values instead.  */
 
-  region_id element_rid
-    = array_reg->get_element (this, array_view_rid, index_sid, ctxt);
+struct bad_pointer_finder
+{
+  bad_pointer_finder (const region *reg, enum poison_kind pkind,
+		      region_model_manager *mgr)
+  : m_reg (reg), m_pkind (pkind), m_mgr (mgr), m_count (0)
+  {}
 
-  return get_or_create_view (element_rid, type, ctxt);
-}
+  void on_binding (const binding_key *, const svalue *&sval)
+  {
+    if (const region_svalue *ptr_sval = sval->dyn_cast_region_svalue ())
+      {
+	const region *ptr_dst = ptr_sval->get_pointee ();
+	/* Poison ptrs to descendents of REG, but not to REG itself,
+	   otherwise double-free detection doesn't work (since sm-state
+	   for "free" is stored on the original ptr svalue).  */
+	if (ptr_dst->descendent_of_p (m_reg)
+	    && ptr_dst != m_reg)
+	  {
+	    sval = m_mgr->get_or_create_poisoned_svalue (m_pkind,
+							 sval->get_type ());
+	    ++m_count;
+	  }
+      }
+  }
 
-/* Get a region of type TYPE for PTR_SID + OFFSET_SID.
+  const region *m_reg;
+  enum poison_kind m_pkind;
+  region_model_manager *const m_mgr;
+  int m_count;
+};
 
-   If OFFSET_SID is known to be zero, then dereference PTR_SID.
-   Otherwise, impose a view of "typeof(*PTR_SID)[]" on *PTR_SID,
-   and then get a view of type TYPE on the relevant array element.  */
+/* Find any pointers to REG or its descendents; convert them to
+   poisoned values of kind PKIND.
+   Return the number of pointers that were poisoned.  */
+// FIXME: ^^ unit test for this?
 
-region_id
-region_model::get_or_create_pointer_plus_expr (tree type,
-					       svalue_id ptr_sid,
-					       svalue_id offset_in_bytes_sid,
-					       region_model_context *ctxt)
+int
+region_model::poison_any_pointers_to_descendents (const region *reg,
+						   enum poison_kind pkind)
 {
-  return get_or_create_mem_ref (type,
-				ptr_sid,
-				offset_in_bytes_sid,
-				ctxt);
+  bad_pointer_finder bv (reg, pkind, m_mgr);
+  m_store.for_each_binding (bv);
+  return bv.m_count;
 }
 
-/* Get or create a view of type TYPE of the region with id RAW_ID.
-   Return the id of the view (or RAW_ID if it of the same type).  */
+/* Attempt to merge THIS with OTHER_MODEL, writing the result
+   to OUT_MODEL.
+   FIXME: POINT  */
 
-region_id
-region_model::get_or_create_view (region_id raw_rid, tree type,
-				  region_model_context *ctxt)
+bool
+region_model::can_merge_with_p (const region_model &other_model,
+				const program_point &point,
+				region_model *out_model) const
 {
-  region *raw_region = get_region (raw_rid);
+  gcc_assert (out_model);
+  gcc_assert (m_mgr == other_model.m_mgr);
+  gcc_assert (m_mgr == out_model->m_mgr);
 
-  gcc_assert (TYPE_P (type));
-  if (type != raw_region->get_type ())
-    {
-      /* If the region already has a view of the requested type,
-	 reuse it.  */
-      region_id existing_view_rid = raw_region->get_view (type, this);
-      if (!existing_view_rid.null_p ())
-	return existing_view_rid;
-
-      /* Otherwise, make one (adding it to the region_model and
-	 to the viewed region).  */
-      region_id view_rid = add_region_for_type (raw_rid, type, ctxt);
-      raw_region->add_view (view_rid, this);
-      // TODO: something to signify that this is a "view"
-      return view_rid;
-    }
+  if (m_current_frame != other_model.m_current_frame)
+    return false;
+  out_model->m_current_frame = m_current_frame;
 
-  return raw_rid;
+  model_merger m (this, &other_model, point, out_model);
+
+  if (!store::can_merge_p (&m_store, &other_model.m_store,
+			   &out_model->m_store, m_mgr->get_store_manager (),
+			   &m))
+    return false;
+
+  /* Merge constraints.  */
+  constraint_manager::merge (*m_constraints,
+			      *other_model.m_constraints,
+			      out_model->m_constraints,
+			      m);
+
+  return true;
 }
 
 /* Attempt to get the fndecl used at CALL, if known, or NULL_TREE
